!==========================!
!======= allocation =======!
!==========================!
module mod_allocation

use globals
implicit none	

contains

    subroutine allocation

    integer :: itemp
    integer :: ir,iz,izt,izf,totgrp

    totgrp = nr*nz*nzt*nzf

    allocate(fam1(t0:tt-1),fam2(t0:tt-1))                     ! pre-multiplication factors
    allocate(phi(t0:tt),delta(t0:tt))                         ! equivalence scale, utility weight    
    allocate(phi_inc(t0:tt))                                  ! equivalence scale income     
    
    allocate(cstrr(tr:tt,nr,na))                              ! optimal cons (c 'star') in retirement
	allocate(ducstrr(tr:tt,nr,na))                            ! mg. utility of c 'star' in retirement

	allocate(cstrw(t0:tw,totgrp,na))                          ! optimal cons (c 'star') when working
	allocate(ducstrw(t0:tw,totgrp,na))                        ! mg. utility of c 'star' when working       
	allocate(ztprob(nzt))  	  	                              ! initial shock draw probabilities
	allocate(z0prob(nz))  	  	                              ! temp. shock draw probabilities
	allocate(zfprob(nzf))  	  	                              ! ff shock draw probabilities	
		
	allocate(lcp(t0:tw))                                      ! lifecycle profiles
	allocate(mwsim(t0:tw),mwsim_eq(t0:tw))                    ! simulated wage statistics
	allocate(pens(nad))                                       ! pensions
	allocate(zgrid(nz),ztrans(nz,nz))                         ! wage shock: permnanent comp.
	allocate(z0grid(nz),ztgrid(nzt),zfgrid(nzf))
	
	! simulation
	allocate(esim(t0:tw,nsim),zsim(t0:tw,nsim))               ! to store wage shocks
	allocate(etsim(t0:tw,nsim),ztsim(t0:tw,nsim))
	allocate(efsim(nsim),zfsim(nsim))
	allocate(wsim(t0:tw,nsim),wsim_eq(t0:tw,nsim))            ! to store simulated gross earnings
	allocate(pensim(nsim))
	allocate(wsimout(t0:tw,nsim))
	allocate(avesim(t0:tw,nsim),avesim1(t0:tw,nsim))
    allocate(izloc(t0:tw,nsim),aveloc(t0:tw,nsim))
    allocate(iztloc(t0:tw,nsim),izfloc(nsim))
    allocate(asim(t0:tt,nsim),csim(t0:tt,nsim),csim_eq(t0:tt,nsim))

    allocate(aminr(tr:tt,nr),amin(t0:tw,nzf))
    allocate(amaxr(tr:tt,nr),amaxw(t0:tw,nzf))
    
    allocate(agrid(t0:tw,nzf,na))
    allocate(agridr(tr:tt,nr,na))

    allocate(pind(nr,nz,nzt,nzf))

    ! pind is used to save on array space
    ! due to f90's 7-dimension array restriction
    itemp = 1

    do ir = 1,nr
    do iz = 1,nz
    do izt = 1,nzt
    do izf = 1,nzf
        pind(ir,iz,izt,izf) = itemp
        itemp = itemp + 1
    enddo
    enddo
    enddo
    enddo

    end subroutine allocation

    
end module mod_allocation