!================================================================!
!======= module with family part outside the optimization =======!
!================================================================!
module mod_family

use globals
implicit none	

contains

    subroutine family
        implicit none
        integer :: it,ia,ic,iap,icp
                
        !-----------------------------------!
        ! equivalence scale: Square root    !
        !-----------------------------------!
     
        do it = t0,tt
            phi(it) = (detadults(it) + detchild(it))**0.5d0
        enddo
        
        if (famtype==0) then
            phi_inc=phi     
            phi=one
        else
            phi_inc=one
        endif

        !----------------!            
        ! utility weight !
        !----------------!
  
        if (famtype==0) then
            delta=one
        else
            if (uwtype==0) then
                delta=phi**(1d0-eta)
            elseif (uwtype==1) then
                delta=one
            elseif (uwtype==2) then
                delta=phi      
            elseif (uwtype==3) then
                do it=t0,tt
                    delta(it)=detadults(it)+detchild(it)
                enddo
            endif
        endif
        
        !-----------------------------------------------------------------------------------!
        ! pre-multiplication factors from the euler equation and the endogenous grid method !
        !   - this essentially follows the notation in the violante notes                   !               
        !-----------------------------------------------------------------------------------!               
        do it=t0,tt-1
            fam1(it) = delta(it+1)*phi(it+1)**(eta-one)                
            fam2(it) = delta(it)**(one/eta)*phi(it)**(one-one/eta)            
        enddo
                  
            
    end subroutine family
	
end module mod_family    