!===========================================!
!======= module to write data =======!
!===========================================!
module mod_outdata

use globals
use mysubs
implicit none	

contains

    subroutine outdata
         
        character :: k=','
        integer :: it,isim,izf,iz,iz1,izt,ia,ic,ir,iw,peakage(1)
        real(dp),dimension(t0:tt) :: adaux,chaux,cvar_eq,cvar,ymean,yvar,ymean_eq,yvar_eq, &
                                 amean,avar,amean_eq,avar_eq,bc,amean_bc,amean_eq_bc,ymean_bc,ymean_eq_bc, & 
                                 cmean_bc,cmean_eq_bc,adtemp,chtemp,phitemp,lcvar, &
                                 dlogcm,insurance,insurancet,lyvar,lymean,lyvar_eq,lymean_eq
        real,dimension(tr:tt,nsim) :: pens_raw,pens_eq
        real,dimension(t0:tt,nsim) :: csim_eq_discount,asim_eq 
        real(dp),dimension(nsim) :: ltc_eq
        real(dp) :: meanltc_eq, varltc_eq,meanltc_eq_annual, varltc_eq_annual,auxv
        real(dp) :: wa2,wc1,wc2

        real(dp) :: vtemp,vtemp_d,wtemp,prtemp(2)
        integer  :: indtemp(2),avetemp
        
        ! ===================================================
        ! when famtype=0, aggregate single household model to
        ! household data using equivalence scales
        ! ===================================================
    	open(17,file='inputfiles\adults.txt')
    	read(17,*) adtemp(:)
    	close(17)

    	open(17,file='inputfiles\nchild.txt')
    	read(17,*) chtemp(:)
    	close(17)
    	
    	chtemp(65:tt)=0
    	
        do it=t0,tt
            phitemp(it)=(adtemp(it)+chtemp(it))**0.5          
        enddo

        !======================
        ! individual data                    
        !======================
      
        ! obtain equivalized consumption and wages
        if (famtype==2) then
            do it=t0,tw
                csim_eq(it,:)=csim(it,:)/phitemp(it)    ! phi is the same for all households
                wsim_eq(it,:)=wsimout(it,:)/phitemp(it)
                asim_eq(it,:)=asim(it,:)/phitemp(it)
            enddo
            do it=tr,tt
                csim_eq(it,:)=csim(it,:)/phitemp(it)
                pens_raw(it,:)=pensim(:)
                pens_eq(it,:)=pensim(:)/phitemp(it)
                asim_eq(it,:)=asim(it,:)/phitemp(it)    
            enddo
        else
            asim_eq=asim
            csim_eq=csim
            wsim_eq=wsim
            do it=tr,tt
                pens_raw(it,:)=pensim
                pens_eq(it,:)=pens_raw(it,:)/phitemp(it)
            enddo
        endif
                     
        !======================
        ! aggregate moments over the life cycle
        !======================
        
        do it=t0,tt
      
            cmean(it)=sum(csim(it,:))/(one*nsim)
            cmean_eq(it)=sum(csim_eq(it,:))/(one*nsim)
 
            lcmean(it)= sum(log(csim_eq(it,:)))/(one*nsim)
            lcvar(it)=(sum((log(csim_eq(it,:))-lcmean(it))**2)/(one*nsim))**0.5
                        
            cvar(it)=(sum((csim(it,:)-cmean(it))**2)/(one*nsim))**0.5
            cvar_eq(it)=(sum((csim_eq(it,:)-cmean_eq(it))**2)/(one*nsim))**0.5
          
            amean(it)=sum(asim(it,:))/(one*nsim)
            amean_eq(it)=sum(asim_eq(it,:))/(one*nsim)
            
            avar(it)=(sum((asim(it,:)-amean(it))**2)/(one*nsim))**0.5
            avar_eq(it)=(sum((asim_eq(it,:)-amean_eq(it))**2)/(one*nsim))**0.5
   
        enddo
        
        do it=t0,tw
            ymean(it)= sum(wsim(it,:))/(one*nsim)
            ymean_eq(it)=sum(wsim_eq(it,:))/(one*nsim) 
            
            lymean(it)=sum(log(wsim(it,:)))/(one*nsim)
            lymean_eq(it)=sum(log(wsim_eq(it,:)))/(one*nsim)
            
            yvar(it)=(sum((wsim(it,:)-ymean(it))**2)/(one*nsim))**0.5
            yvar_eq(it)=(sum((wsim_eq(it,:)-ymean_eq(it))**2)/(one*nsim))**0.5  
            
            lyvar(it)=(sum((log(wsim(it,:))-lymean(it))**2)/(one*nsim))**0.5
            lyvar_eq(it)=(sum((log(wsim_eq(it,:))-lymean_eq(it))**2)/(one*nsim))**0.5  
                                     
        enddo
                
        if (famtype==0) then
            adaux=one
            chaux=0d0
        elseif (famtype==2) then
            adaux=detadults
            chaux=detchild
        endif     
        
        ! fraction of those 
        !   - with zero assets (zero borrowing constraint) or
        !   - with zero or negative assets (natural borrowing constraint)
        bc=0d0
        do isim=1,nsim
        do it=t0,tt
            if(asim(it,isim)<=0d0+0.001) bc(it)=bc(it)+one
        enddo
        enddo
        
        amean_bc=0d0
        amean_eq_bc=0d0
        ymean_bc=0d0
        ymean_eq_bc=0d0
        cmean_bc=0d0
        cmean_eq_bc=0d0
        
        ! insurance coefficients
        insurance(t0) = 0.0_dp
        insurancet(t0) = 0.0_dp
            
        do it = t0+1,tw
            !dlogcm(it) = sum(log(csim_eq(it,:)) - log(csim_eq(it-1,:))) / (one*nsim)
            insurance(it) =  sum(   (log(csim_eq(it,:)) - log(csim_eq(it-1,:)) ) &
                                  * (zsim(it,:)-rho*zsim(it-1,:)) &
                                )
            insurance(it) = insurance(it) / sum((zsim(it,:)-rho*zsim(it-1,:))**2.0_dp)
            
            insurance(it) = one -  insurance(it)
            !print*, it,dlogcm(it),insurance(it),sum(zsim(it,:)**2.0_dp)

            insurancet(it) =  sum( (log(csim_eq(it,:)) - log(csim_eq(it-1,:)) ) &
                                 * ztsim(it,:) &
                                 )
            insurancet(it) = insurancet(it) / sum((ztsim(it,:))**2.0_dp)
            
            insurancet(it) = one -  insurancet(it)
            
!                print*, minval(csim_eq(it,:)),minval(csim(it,:)), &
!                        insurance(it),insurancet(it)
            
        enddo


        1  format(i5,3(a1,i2),5(a1,f14.2))    
        2  format(a)            
        3  format(i3,2(a1,f8.4),21(a1,f14.5))
        30  format(i,4(a1,f18.4),2(a1,f18.4),2(a1,f18.4),30(a1,f18.5))
        
        auxv=0d0

        open(101,file=trim(adjustl(fname_mean)))                
        write(101,2) "t, beta, ky_ratio, lcm, lcsd, ad, ch, a, a_eq, va, va_eq, c, c_eq, &
                      vc, vc_eq, y, y_eq, vy, vy_eq, delta, phi, bc, abc, &
                      abc_eq, cbc, cbc_eq, ybc, ybc_eq,phi_inc,insurance_p,insurance_t,labortax,ly,ly_eq,vly,vly_eq"
        
        do it=t0,tw
            ! time period, beta, adults, children, consumption, consumption variance,income (c, cvar, y: raw&equivalized)
            write(101,30)   it,k,beta,k,kymodel,k,lcmean(it),k,lcvar(it),k,adaux(it),k,chaux(it),k, &
                            amean(it),k,amean_eq(it),k,avar(it),k,avar_eq(it),k, &            
                            cmean(it),k,cmean_eq(it),k,cvar(it),k,cvar_eq(it),k, &
                            ymean(it),k,ymean_eq(it),k,yvar(it),k,yvar_eq(it),k, &
                            delta(it),k,phi(it),k,bc(it),k, &
                            amean_bc(it),k,amean_eq_bc(it),k, &
                            cmean_bc(it),k,cmean_eq_bc(it),k, &
                            ymean_bc(it),k,ymean_eq_bc(it),k,phi_inc(it),k,insurance(it),k,insurancet(it),k,tau0,k,&
                            lymean(it),k,lymean_eq(it),k,lyvar(it),k,lyvar_eq(it)
        enddo     
          
        do it=tr,tt
            ! time period, beta, adults, children, consumption, consumption variance,income (c, cvar, y: raw&equivalized)
            write(101,30)   it,k,beta,k,kymodel,k,lcmean(it),k,lcvar(it),k,adaux(it),k,chaux(it),k, &
                            amean(it),k,amean_eq(it),k,avar(it),k,avar_eq(it),k, &   
                            cmean(it),k,cmean_eq(it),k,cvar(it),k,cvar_eq(it),k, &
                            sum(pens_raw(it,:))/(one*nsim),k,sum(pens_eq(it,:))/(one*nsim),k, &
                            auxv,k,auxv,k,delta(it),k,phi(it),k,bc(it),k, &
                            amean_bc(it),k,amean_eq_bc(it),k, &
                            cmean_bc(it),k,cmean_eq_bc(it),k, &
                            ymean_bc(it),k,ymean_eq_bc(it),k,phi_inc(it)
        enddo

        close(101)
        
        ! life-time equivalized consumption
        do isim=1,nsim
            do it=t0,tt
                csim_eq_discount(it,isim)=csim_eq(it,isim)/(r/surv(it-1))**(it-t0)
            enddo
            ltc_eq(isim)=sum(csim_eq_discount(:,isim))
        enddo
        meanltc_eq=sum(ltc_eq)/(nsim*one)
        varltc_eq=(sum((ltc_eq-meanltc_eq)**2)/(one*nsim))**0.5
        
        meanltc_eq_annual=meanltc_eq/((tt-t0+1)*one)
        varltc_eq_annual=varltc_eq/((tt-t0+1)*one) 
        ! note: not squared because varltc_eq is in fact the standard deviation        

       4  format(4(f14.2,a1),1(f16.10,a1),f5.2,a1,i3)

       peakage=maxloc(cmean_eq)

       open(101,file=trim(adjustl(fname_ltc)))
       write(101,2) "meanltc_eq, varltc_eq,meanltc_eq_annual, varltc_eq_annual, avg_insurance,peakratio,peakage"
       write(101,4) meanltc_eq,k,   varltc_eq,k,    meanltc_eq_annual,k,    varltc_eq_annual,k, &
                    sum(insurance(t0+1:tw))/(tw-t0+1),k, &
                    maxval(cmean_eq)/cmean_eq(t0),k,peakage
       close(101)        
            
       print *, "Peak age & ratio: ", peakage+24, " ",maxval(cmean_eq)/cmean_eq(t0)
       print *, "Var ln c at 25 and 66: ",lcvar(t0), " ",lcvar(tr)       
       print *, "Interest rate", r
            
    end subroutine outdata
    
end module mod_outdata