!===========================================!
!======= module to read external data =======!
!===========================================!
module mod_readextdata

use globals
implicit none

contains

    subroutine readextdata_lcp				
        			
        open(100,file='inputfiles\exphh.txt')       
        
        do i = t0,tw
            read(100,*) lcp(i)
        enddo
        
        close(100)
        
        ! read in survival probabilities (prob. of surviving another year)
        ! (note: txt file contains surv. probabilities until age 95)
        ! (note: timing --> surv(it) is the probability i will be alive
        !   at age it+1, conditional on being alive at age it)
        
        surv(t0-1)  = one
        unconsurv(t0) = one

        open(120,file='inputfiles\survival_25to95.txt')

        do i = t0,tt-1
            read(120,*) surv(i)          
            if (i>t0)   unconsurv(i) = unconsurv(i-1)*surv(i-1)
        enddo
        surv(tt) = 0.0_dp
        unconsurv(tt) = unconsurv(tt-1)*surv(tt-1)
        close(120)

        ! population by age as a share of total population
        do i = t0,tt
            alive(i) = unconsurv(i)/sum(unconsurv)
        enddo
        
        do i = t0,tw
            alivew(i) = unconsurv(i)/sum(unconsurv(t0:tw))
        enddo
                  
    end subroutine readextdata_lcp
       
    subroutine readextdata_detfam
	    character(len=50) :: filename
    	
    	! read in average number of adults
    	! and children during the lifecycle
    	
    	open(37,file='inputfiles\adults.txt')
    	read(37,*)  detadults(:)
    	close(37)

    	open(37,file='inputfiles\nchild.txt')
    	read(37,*)  detchild(:)
    	close(37)
    	detchild(60:tt)=0d0

    end subroutine readextdata_detfam
    
end module mod_readextdata